#ifndef RECORD_H
#define RECORD_H

#include "gmc-common_global.h"

#include <QVariant>

class GMC_COMMON_SHARED_EXPORT Record
{

    friend class RecordModel;

public:

    Record();
    virtual ~Record();

    bool isChanged() const;
    virtual bool isEmpty() const = 0;
    virtual bool isValid() const = 0;
    virtual bool isEditable( int /*i*/ ) const = 0;

    virtual QVariant data( int /*i*/, int role ) const = 0;
    virtual bool setData( int /*i*/, const QVariant & /*value*/ ) = 0;

protected:

    void unchange();

protected:

    bool _changed;

};

#endif // RECORD_H
