#ifndef STREAMINTERCEPTOR_H
#define STREAMINTERCEPTOR_H

#include "gmc-common_global.h"

#include <QTemporaryFile>

class GMC_COMMON_SHARED_EXPORT StreamInterceptor : public QTemporaryFile
{

public:

    StreamInterceptor( FILE * /*stream*/ );
    virtual ~StreamInterceptor();

    QByteArray streamReadAll();

protected:

    int _streamDescriptor;
    int _backupDescriptor;
    FILE *_fileStream;

};

#endif // STREAMINTERCEPTOR_H
