#ifndef TREENODEMODELEXTENSION_H
#define TREENODEMODELEXTENSION_H

#include "gmc-common_global.h"

class QModelIndex;
class QItemSelectionRange;
class QItemSelection;

class TreeNode;

class GMC_COMMON_SHARED_EXPORT TreeNodeModelExtension
{

public:

    TreeNodeModelExtension() {}
    virtual ~TreeNodeModelExtension() {}

    virtual TreeNode * rootNode() const = 0;

    virtual TreeNode * toTreeNode( const QModelIndex & /*index*/ ) const = 0;
    virtual TreeNode * toTreeNode( const QItemSelectionRange & /*selectionRange*/ ) const = 0;
    virtual TreeNode * toTreeNode( const QItemSelection & /*selection*/ ) const = 0;

    virtual QModelIndex treeNodeToIndex( TreeNode * /*element*/ ) const = 0;

};

#endif // TREENODEMODELEXTENSION_H
